<?php
    class DiyoVM_Module extends ServerModule
    {
        private $api,$diyovm;
        function __construct($server,$options = []){
            $this->_name = __CLASS__;
            parent::__construct($server,$options);
        }
        protected function define_server_info($server=[]){
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->diyovm = [
                "address" => $_POST["name"],
                "username" => $_POST["username"],
                "password" => $_POST["password"]
            ];
        }
        public function testConnect(){
            $connection = $this->api->beTestConnection($this->diyovm);
            if(!$connection["status"]){
                $this->error = $connection["message"];
                return false;
            }
            return true;
        }
        public function config_options($data = []){
            return [
                "clusterId" => [
                    "name"              => "Cluster",
                    "description"       => "DiyoVM sistemindeki cluster değerini girdiğiniz sunucuya kurulur",
                    "type"              => "text",
                    "width"             => "100",
                    "value"             => isset($data["clusterId"]) ? $data["clusterId"]:"",
                    "placeholder"       => ""
                ],
                "hostId" => [
                    "name"              => "Host",
                    "description"       => "DiyoVM sistemindeki host değerini girdiğiniz sunucuya kurulur",
                    "type"              => "text",
                    "width"             => "100",
                    "value"             => isset($data["hostId"]) ? $data["hostId"]:"",
                    "placeholder"       => ""
                ],
                "poolId" => [
                    "name"              => "Havuz",
                    "description"       => "DiyoVM sistemindeki havuz değerini girdiğini havuzu kullanır",
                    "type"              => "text",
                    "width"             => "100",
                    "value"             => isset($data["poolId"]) ? $data["poolId"]:"",
                    "placeholder"       => ""
                ],
                "datastoreId" => [
                    "name"              => "Disk",
                    "description"       => "DiyoVM sistemindeki kaynak değerini girdiğini diski kullanır",
                    "type"              => "text",
                    "width"             => "100",
                    "value"             => isset($data["datastoreId"]) ? $data["datastoreId"]:"",
                    "placeholder"       => ""
                ],
                "planId" => [
                    "name"              => "Plan Paketi",
                    "description"       => "DiyoVM sistemindeki paketi girerek direkt kullanın",
                    "type"              => "text",
                    "width"             => "100",
                    "value"             => isset($data["planId"]) ? $data["planId"]:"",
                    "placeholder"       => ""
                ],
                "ipCustom" => [
                    "name"              => "Özel IP Adresi",
                    "description"       => "Sadece müşteriye özel ürün tanımlarken özel bir ip vermek isterseniz kullanın",
                    "type"              => "text",
                    "width"             => "100",
                    "value"             => isset($data["ipCustom"]) ? $data["ipCustom"]:"",
                    "placeholder"       => ""
                ],
                "ipCount" => [
                    "name"              => "IP Adresi(Adet)",
                    "description"       => "Sunucunun kullanacağı ip adresi adetini seçin",
                    "type"              => "text",
                    "width"             => "100",
                    "value"             => isset($data["ipCount"]) ? $data["ipCount"]:"",
                    "placeholder"       => ""
                ],
                "ipPlanId" => [
                    "name"              => "IP Adresi Paketi",
                    "description"       => "DiyoVM sistemindeki ip adresi girerek direkt kullanın",
                    "type"              => "text",
                    "width"             => "100",
                    "value"             => isset($data["ipPlanId"]) ? $data["ipPlanId"]:"",
                    "placeholder"       => ""
                ],
                "cpuCore" => [
                    "name"              => "CPU Sayısı(Adet)",
                    "description"       => "Sunucunun işlemcinizde kullanacağı çekirdek sayısını belirtin",
                    "type"              => "text",
                    "width"             => "100",
                    "value"             => isset($data["cpuCore"]) ? $data["cpuCore"]:"",
                    "placeholder"       => "2"
                ],
                "cpuPerCount" => [
                    "name"              => "Soket Başına CPU Sayısı",
                    "description"       => "Sunucunuzda 1'den fazla işlemci var ise olacak dağılımı belirtin",
                    "type"              => "text",
                    "width"             => "100",
                    "value"             => isset($data["cpuPerCount"]) ? $data["cpuPerCount"]:"",
                    "placeholder"       => "Bu değeri 1 olarak kullanmanızı tavsiye ederiz"
                ],
                "cpuLimitMhz" => [
                    "name"              => "CPU Limiti(Mhz)",
                    "description"       => "Sunucunun işlemcinizde kullanabiliceği maksimum limiti belirleyin, boş bırakırsanız kullanılmaz",
                    "type"              => "text",
                    "width"             => "100",
                    "value"             => isset($data["cpuLimitMhz"]) ? $data["cpuLimitMhz"]:"",
                    "placeholder"       => "2900"
                ],
                "ramGB" => [
                    "name"              => "Ram Miktarı(GB)",
                    "description"       => "Sunucunun sahip olacağı ram miktarını belirtin",
                    "type"              => "text",
                    "width"             => "1",
                    "value"             => isset($data["ramGB"]) ? $data["ramGB"]:"",
                    "placeholder"       => "1024"
                ],
                "diskGB" => [
                    "name"              => "Disk Miktarı(GB)",
                    "description"       => "Sunucunun sahip olacağı disk miktarını belirtin",
                    "type"              => "text",
                    "width"             => "20",
                    "value"             => isset($data["diskGB"]) ? $data["diskGB"]:"",
                    "placeholder"       => "1024"
                ],
                "bandwithGB" => [
                    "name"              => "Bant Genişliği(GB)",
                    "description"       => "Sunucunun sahip olacağı bant genişliği miktarını belirtin",
                    "type"              => "text",
                    "width"             => "10",
                    "value"             => isset($data["bandwithGB"]) ? $data["bandwithGB"]:"",
                    "placeholder"       => "1024"
                ],
                "snapShotCount" => [
                    "name"              => "Yedek Hakkı",
                    "description"       => "Sunucunun alabiliceği yedek hakkını belirleyin (Olmaması İçin 0)",
                    "type"              => "text",
                    "width"             => "3",
                    "value"             => isset($data["snapShotCount"]) ? $data["snapShotCount"]:"",
                    "placeholder"       => "0"
                ],
                "formatOsList" => [
                    "name"              => "Format Şablon Listesi",
                    "description"       => "Eğer özel olarak sadece belirli şablonları kullanarak format atılmasını istiyorsanız bu kısma girin",
                    "type"              => "text",
                    "width"             => "3",
                    "value"             => isset($data["formatOsList"]) ? $data["formatOsList"]:"",
                    "placeholder"       => "5,7"
                ]
            ];
        }

        public function create(array $order_options=[]){
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $selects = $this->val_of_conf_opt;
            $options = $this->order["options"];
            $basic_vals = $options["creation_info"];
            $extra_vals = [
                "clusterId" => "set",
                "hostId" => "set",
                "poolId" => "set",
                "datastoreId" => "set",
                "osId" => "set",
                "planId" => "set",
                "ipCustom" => "set",
                "ipPlanId" => "set",
                "ipCount" => "option",
                "cpuCore" => "option",
                "cpuPerCount" => "set",
                "cpuLimitMhz" => "set",
                "ramGB" => "option",
                "diskGB" => "option",
                "bandwithGB" => "option",
                "snapShotCount" => "option",
                "userPassword" => "set"
            ];
            foreach($basic_vals as $key => $value){
                $basic_vals[$key] = $value;
            }
            foreach($extra_vals as $key => $value){
                if(empty($selects[$key])){
                    continue;
                }
                if($value == "set"){
                    $basic_vals[$key] = $selects[$key];
                }
                else{
                    $basic_vals[$key."Extra"] = $selects[$key];
                }
            }
            $response = $this->api->beCreateVM($basic_vals);
            if(!$response["status"]){
                $this->error = $response["message"];
                self::save_log(
                    'Servers',
                    $this->_name,
                    __FUNCTION__,
                    ['order' => $this->order],
                    $response["message"],
                    "hatakardes"
                );
                return false;
            }
            $firstip = $response["iplist"][0];
            return [
                'ip'                => $firstip,
                'assigned_ips'      => $response["iplist"],
                'login' => [
                    'username' => $response["username"],
                    'password' => $response["password"],
                ],
                'config' => [
                    $this->entity_id_name => $response["sid"],
                    "taskid" => $response["tid"],
                    "status" => 1
                ]
            ];
        }

        public function suspend(){
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $config = $this->options["config"];
            $response = $this->api->beSuspend([
                "vm_id" => $config["vm_id"],
                "action" => "suspend"
            ]);
            if(!$response["status"]){
                $this->error = $response["message"];
                return false;
            }
            $this->options["config"]["status"] = -1;
            Orders::set($this->order["id"],["options" => Utility::jencode($this->options)]);
            return true;
        }

        public function unsuspend(){
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $config = $this->options["config"];
            $response = $this->api->beSuspend([
                "vm_id" => $config["vm_id"],
                "action" => "unsuspend"
            ]);
            if(!$response["status"]){
                $this->error = $response["message"];
                return false;
            }
            $this->options["config"]["status"] = 2;
            Orders::set($this->order["id"],["options" => Utility::jencode($this->options)]);
            return true;
        }

        public function terminate(){
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $config = $this->options["config"];
            $response = $this->api->beDeleteVM([
                "vm_id" => $config["vm_id"]
            ]);
            if(!$response["status"]){
                $this->error = $response["message"];
                self::save_log(
                    'Servers',
                    $this->_name,
                    __FUNCTION__,
                    ['order' => $this->order],
                    $response["message"],
                    "hatakardes"
                );
                return false;
            }
            return true;
        }

        public function apply_updowngrade($params=[])
        {
            error_log(print_r($params,true),true);
            return false;
            /*
            parent::udgrade(); // You can use it to delete the previous virtual server and create the virtual server with new features.
            */

            try
            {
                /*
                 * $this->order["options"]
                * for parameters: https://docs.wisecp.com/en/kb/parameters
                * Here are the codes to be sent to the API...
                */
                $result             = "OK"; #$this->api->upgrade();
            }
            catch (Exception $e){
                $this->error = $e->getMessage();
                self::save_log(
                    'Servers',
                    $this->_name,
                    __FUNCTION__,
                    ['order' => $this->order],
                    $e->getMessage(),
                    $e->getTraceAsString()
                );
                return false;
            }
            /*
            * Error Result:
            * $result             = "Error Message";
            */

            if($result == 'OK')
                return true;
            else
            {
                $this->error = $result;
                return false;
            }
        }
        public function get_status(){
        }
        public function list_vps(){
            return [];
        }
        public function clientArea(){
            global $module;
            $content    = '';
            $_page      = $this->page;
            $config = $this->options["config"];
            $info = $this->options["creation_info"];
            if($_page == "check_format"){
                return $this->get_page("clientArea-format");
            }
            if(!$_page) $_page = 'home';
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beGetVm([
                "vm_id" => $config["vm_id"],
                "iplist" => true,
                "snapshotlist" => true,
                "templatelist" => true,
                "logs" => true,
                "rdnslist" => true,
            ]);
            if(!$response["status"]){
                return $response["message"];
            }
            $vm = $response["server"];
            $vm["sdata"] = json_decode($vm["sdata"],true);
            if($vm["sdata"]["formatting"] != 0){
                $this->options["config"]["taskid"] = $vm["sdata"]["formatting"];
                $this->options["config"]["status"] = 1;
                Orders::set($this->order["id"],["options" => Utility::jencode($this->options)]);
                $link = $this->area_link."?m_page=check_format";
                return "<meta http-equiv=\"refresh\" content=\"0;URL='{$link}'\"/> ";
                exit;
            }
            else{
                $this->options["config"]["status"] = 2;
                Orders::set($this->order["id"],["options" => Utility::jencode($this->options)]);
            }
            $iplist = $response["iplist"];
            $snapshotlist = $response["snapshotlist"] ?? [];
            $templatelist = $response["templatelist"] ?? [];
            $logs = $response["logs"] ?? [];
            $rdnslist = $response["rdnslist"] ?? [];
            foreach($templatelist as $template){
                if($vm["sdata"]["template"] == $template["tid"]){
                    $vm["sdata"]["templatename"] = $template["tname"];
                }
            }
            $content .= $this->get_page('clientArea-'.$_page,[
                "vm" => $vm,
                "iplist" => $iplist,
                "snapshotlist" => $snapshotlist,
                "templatelist" => $templatelist,
                "logs" => $logs,
                "rdnslist" => $rdnslist,
                "info" => $info
            ]);
            return $content;
        }
        public function use_clientArea_status_action(){
            if(!Filter::isPOST()) return false;
            $config = $this->options["config"];
            if($config["status"] != 2){
                echo Utility::jencode([
                    'status' => "error",
                    'message' => "Sunucunuzuz bu işlem için kurulu olması gerek!",
                ]);
                return false;
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            switch($_POST["action"]){
                case "start" : 
                    Orders::add_history($user_id,$this->order["id"],'server-order-start');
                    break;
                case "stop" : 
                    Orders::add_history($user_id,$this->order["id"],'server-order-stop');
                    break;
                case "restart" : 
                    Orders::add_history($user_id,$this->order["id"],'server-order-restart');
                    break;
            }
            $response = $this->api->beStatusAction([
                "vm_id" => $config["vm_id"],
                "action" => $_POST["action"]
            ]);
            echo json_encode($response,JSON_UNESCAPED_UNICODE);
        }
        public function use_clientArea_create_snapshot(){
            if(!Filter::isPOST()) return false;
            $config = $this->options["config"];
            $info = $this->options["creation_info"];
            if($config["status"] != 2){
                echo Utility::jencode([
                    'status' => "error",
                    'message' => "Sunucunuzuz bu işlem için kurulu olması gerek!",
                ]);
                return false;
            }
            if($info["snapShotCount"] == 0){
                echo Utility::jencode([
                    'status' => "error",
                    'message' => "Sunucunuzuz bu işlem için izni yok!",
                ]);
                return false;
            }

            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beGetVm([
                "vm_id" => $config["vm_id"],
                "snapshotlist" => true
            ]);
            if(!$response["status"]){
                return $response["message"];
            }
            $snapshotlist = $response["snapshotlist"] ?? [];
            if(count($snapshotlist) >= $info["snapShotCount"]){
                echo Utility::jencode([
                    'status' => "error",
                    'message' => "Maksimum yedek sayısına ulaştınız!",
                ]);
                return false;
            }
            $response = $this->api->beCreateSnapshot([
                "vm_id" => $config["vm_id"]
            ]);
            echo json_encode($response,JSON_UNESCAPED_UNICODE);
        }
        public function use_clientArea_deploy_snapshot(){
            if(!Filter::isPOST()) return false;
            $config = $this->options["config"];
            if($config["status"] != 2){
                echo Utility::jencode([
                    'status' => "error",
                    'message' => "Sunucunuzuz bu işlem için kurulu olması gerek!",
                ]);
                return false;
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beDeploySnapshot([
                "vm_id" => $config["vm_id"],
                "ssid" => $_POST["ssid"]
            ]);
            echo json_encode($response,JSON_UNESCAPED_UNICODE);
        }
        public function use_clientArea_delete_snapshot(){
            if(!Filter::isPOST()) return false;
            $config = $this->options["config"];
            if($config["status"] != 2){
                echo Utility::jencode([
                    'status' => "error",
                    'message' => "Sunucunuzuz bu işlem için kurulu olması gerek!",
                ]);
                return false;
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beDeleteSnapshot([
                "vm_id" => $config["vm_id"],
                "ssid" => $_POST["ssid"]
            ]);
            echo json_encode($response,JSON_UNESCAPED_UNICODE);
        }
        public function use_clientArea_create_dnsrecord(){
            if(!Filter::isPOST()) return false;
            $config = $this->options["config"];
            if($config["status"] != 2){
                echo Utility::jencode([
                    'status' => "error",
                    'message' => "Sunucunuzuz bu işlem için kurulu olması gerek!",
                ]);
                return false;
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beCreateDnsRecord([
                "vm_id" => $config["vm_id"],
                "iid" => $_POST["ipaddress"],
                "type" => $_POST["type"],
                "dns" => $_POST["dns"],
                "priority" => $_POST["priority"],
                "ttl" => $_POST["ttl"],
            ]);
            if(!$response["status"]){
                echo json_encode($response);
                exit;
            }
            echo json_encode($response,JSON_UNESCAPED_UNICODE);
        }
        public function use_clientArea_edit_dnsrecord(){
            if(!Filter::isPOST()) return false;
            $config = $this->options["config"];
            if($config["status"] != 2){
                echo Utility::jencode([
                    'status' => "error",
                    'message' => "Sunucunuzuz bu işlem için kurulu olması gerek!",
                ]);
                return false;
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beEditDnsRecord([
                "vm_id" => $config["vm_id"],
                "rid" => $_POST["rid"],
                "iid" => $_POST["ipaddress"],
                "type" => $_POST["type"],
                "dns" => $_POST["dns"],
                "priority" => $_POST["priority"],
                "ttl" => $_POST["ttl"],
            ]);
            if(!$response["status"]){
                echo json_encode($response);
                exit;
            }
            echo json_encode($response,JSON_UNESCAPED_UNICODE);
        }
        public function use_clientArea_delete_dnsrecord(){
            if(!Filter::isPOST()) return false;
            $config = $this->options["config"];
            if($config["status"] != 2){
                echo Utility::jencode([
                    'status' => "error",
                    'message' => "Sunucunuzuz bu işlem için kurulu olması gerek!",
                ]);
                return false;
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beDeleteDnsRecord([
                "vm_id" => $config["vm_id"],
                "rid" => $_POST["rid"]
            ]);
            if(!$response["status"]){
                echo json_encode($response);
                exit;
            }
            echo json_encode($response,JSON_UNESCAPED_UNICODE);
        }
        public function use_clientArea_password(){
            if(!Filter::isPOST()) return false;
            $config = $this->options["config"];
            if($config["status"] != 2){
                echo Utility::jencode([
                    'status' => "error",
                    'message' => "Sunucunuzuz bu işlem için kurulu olması gerek!",
                ]);
                return false;
            }
            $password = $_POST["password"];
            $this->options["login"]["password"] = $password;
            Orders::set($this->order["id"],["options" => Utility::jencode($this->options)]);
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->bePasswordVM([
                "vm_id" => $config["vm_id"],
                "onserver" => isset($_POST["onserver"]) ? true:false,
                "password" => $password
            ]);
            if(!$response["status"]){
                echo json_encode($response);
                exit;
            }
            echo json_encode($response,JSON_UNESCAPED_UNICODE);
        }
        public function use_clientArea_format(){
            if(!Filter::isPOST()) return false;
            $config = $this->options["config"];
            $info = $this->options["creation_info"];
            if($config["status"] != 2){
                echo Utility::jencode([
                    'status' => "error",
                    'message' => "Sunucunuzuz bu işlem için kurulu olması gerek!",
                ]);
                return false;
            }
            if(!isset($_POST["approval"])){
                echo Utility::jencode([
                    'status' => "error",
                    'message' => "Lütfen tüm bilgilerinizin siliniceğini onaylayın!",
                ]);
                return false;
            }
            if(!isset($_POST["approval2"])){
                echo Utility::jencode([
                    'status' => "error",
                    'message' => "Lütfen tüm yedeklerinizin siliniceğini onaylayın!",
                ]);
                return false;
            }
            $checkallow = false;
            $allowtemplate = $info["formatOsList"];
            if($allowtemplate){
                if(strpos($allowtemplate,",") !== false){
                    $allow = explode(",",$allowtemplate);
                    if(count($allow) > 1){
                        $allowed = $allow;
                        $checkallow = true;
                    }
                }
                else{
                    $allowed[] = $allowtemplate;
                    $checkallow = true;
                }
                if($checkallow){
                    if(!in_array($_POST["template"],$allowed)){
                        echo Utility::jencode([
                            'status' => "error",
                            'message' => "Belirtilen yedek sizin için kullanılamaz!",
                        ]);
                        return false;
                    }
                }
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beFormatVM([
                "vm_id" => $config["vm_id"],
                "template" => $_POST["template"],
                "password" => $_POST["password"]
            ]);
            if($response["status"]){
                $this->options["login"]["password"] = $_POST["password"];
                $this->options["config"]["taskid"] = $response["taskid"];
                $this->options["config"]["status"] = 1;
                Orders::set($this->order["id"],["options" => Utility::jencode($this->options)]);
            }
            echo json_encode($response,JSON_UNESCAPED_UNICODE);
        }
        public function use_clientArea_check_stat(){
            $config = $this->options["config"];
            $ch = curl_init();
            curl_setopt($ch,CURLOPT_URL,"https://{$this->server['name']}/app/tasks/statserver.php?vmlist={$config['vm_id']}");
            curl_setopt($ch,CURLOPT_SSL_VERIFYHOST,false);
            curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,false);
            curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
            $response = curl_exec($ch);
            curl_close($ch);
            $response = json_decode($response,true);
            if($response[$config["vm_id"]]){
                echo json_encode(["vmdata" => $response[$config["vm_id"]]]);
            }
            exit;
        }
        public function use_clientArea_check_format2(){
            $ch = curl_init();
            curl_setopt($ch,CURLOPT_URL,"https://{$this->server['name']}/app/tasks/createserver.php");
            curl_setopt($ch,CURLOPT_SSL_VERIFYHOST,false);
            curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,false);
            curl_exec($ch);
            echo json_encode([
                "status" => 1
            ],JSON_UNESCAPED_UNICODE);
            curl_close($ch);
        }
        public function use_clientArea_check_format(){
            if(!Filter::isPOST()) return false;
            $config = $this->options["config"];
            if($config["status"] != 1){
                echo json_encode(["refresh" => 1]);
                exit;
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beGetTask([
                "taskid" => $config["taskid"]
            ]);
            if(!$response["status"]){
                echo Utility::jencode([
                    'status' => "error",
                    'message' => $response["message"],
                ]);
                return false;
            }
            $task = $response["task"];

            $laststep = (int)$_POST["laststep"];
            $steps = [
                0 => "Siliniyor!",
                1 => "Kurulum için hazırlanıyor!",
                2 => "Kurulum yapılıyor",
                3 => "Disk Ayarlanıyor",
                4 => "Sunucu Başlatılıyor",
                5 => "Ip adresleri tanımlanıyor!"
            ];
            if($task["tstatus"] == 0){
                $this->options["config"]["status"] = 2;
                Orders::set($this->order["id"],["options" => Utility::jencode($this->options)]);
                echo json_encode(["refresh" => 1]);
                exit;
            }
            $tdata = json_decode($task["tdata"],true);
            $stepnow = $tdata["status"]["step"];
            if($laststep == $stepnow){
                if($stepnow == 2){
                    echo json_encode(["percent" => $tdata["vars"]["percent"]]);
                    exit;
                }
                echo json_encode(["stepnow" => $stepnow]);
                exit;
            }
            $start = 1;
            if($stepnow == 14){
                $start = 0;
                $stepnow = 0;
            }
            $stepscontent = "";
            for($i = $start; $i < 6; $i++){
                if($stepnow > $i){
                    $stepscontent .= "<li class=\"maked\"><span>{$steps[$i]}</span><i class=\"fa fa-check\"></i></li>";
                }
                else if($stepnow == $i){
                    $activestep = $steps[$i];
                    if($i == 2){
                        $extradata = " <span class=\"percentServer\">%".$tdata["vars"]["percent"]."</span>";
                    }
                    $stepscontent .= "<li class=\"active\"><span>{$activestep}{$extradata}</span><i class=\"fa fa-refresh fa-spin\"></i></li>";
                }
                else{
                    $stepscontent .= "<li class=\"waiting\"><span>{$steps[$i]}</span><i class=\"fa fa-close\"></i></li>";
                }
            }
            echo json_encode(["steps" => $stepscontent,"steptext" => $activestep,"stepnow" => $stepnow,"data" => $tdata]);
        }
        public function adminArea_buttons()
        {
            $buttons = [];
            $config = $this->options["config"];
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beGetVm([
                "vm_id" => $config["vm_id"]
            ]);
            if(!$response["status"]){
                return $response["message"];
            }
            $vm = $response["server"];
            $sdata = json_decode($vm["sdata"],true);

            if($sdata["stats"]["power_status"] == 1)
            {
                $buttons['restart']     = [
                    'text'  => $this->lang["restart"],
                    'type'  => 'transaction',
                ];
                $buttons['stop']      = [
                    'text'  => $this->lang["stop"],
                    'type'  => 'transaction',
                ];
            }
            else
            {
                $buttons['start']      = [
                    'text'  => $this->lang["start"],
                    'type'  => 'transaction',
                ];
            }

            return $buttons;
        }
        public function use_adminArea_SingleSignOn()
        {
            $server = $this->server;
            $config = $this->options["config"];
            Utility::redirect("https://".$server["name"]."/api_login?email=".$server["username"]."&hash=".$server["access_hash"]."&redirect=server&id=".$config["vm_id"]);
            echo "Redirecting...";
        }

        public function use_adminArea_root_SingleSignOn()
        {
            $server = $this->server;
            Utility::redirect("https://".$server["name"]."/api_login?email=".$server["username"]."&hash=".$server["access_hash"]);
            echo "Redirecting...";
        }
        public function use_adminArea_start()
        {
            $config = $this->options["config"];
            if($config["status"] != 2){
                return false;
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            Orders::add_history($user_id,$this->order["id"],'server-order-start');
            $response = $this->api->beStatusAction([
                "vm_id" => $config["vm_id"],
                "action" => "start"
            ]);
            if(!$response["status"]){
                return false;
            }
            return true;
        }
        public function use_adminArea_stop()
        {
            $config = $this->options["config"];
            if($config["status"] != 2){
                return false;
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            Orders::add_history($user_id,$this->order["id"],'server-order-stop');
            $response = $this->api->beStatusAction([
                "vm_id" => $config["vm_id"],
                "action" => "stop"
            ]);
            if(!$response["status"]){
                return false;
            }
            return true;
        }
        public function use_adminArea_restart()
        {
            $config = $this->options["config"];
            if($config["status"] != 2){
                return false;
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            Orders::add_history($user_id,$this->order["id"],'server-order-restart');
            $response = $this->api->beStatusAction([
                "vm_id" => $config["vm_id"],
                "action" => "restart"
            ]);
            if(!$response["status"]){
                return false;
            }
            return true;
        }
    }